--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -5161,8 +5516,50 @@
 	(void) ddi_dma_sync(pkt->pkt_cmd_dma, 0, 0, DDI_DMA_SYNC_FORDEV);
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
+
+	/*
+	 * In case fw does not have the loop id ready, driver assume 0 is
+	 * used since this is p2p and there is only one remote port.
+	 */
+	if (id == LAST_LOCAL_LOOP_ID + 1) {
+		EL(ha, "out of range loop id; rval=%xh, id=%xh, d_id=%xh\n",
+		    rval, id, d_id.b24);
+	} else {
+		EL(ha, "remote port loop_id '%x' has been logged in, d_id=%x\n",
+		    id, d_id.b24);
+	}
+
 	tq = ql_d_id_to_queue(ha, d_id);
+
+	/*
+	 * LV could use any d_id it likes.
+	 * tq may not be available yet.
+	 */
+	if (tq == NULL) {
+		if (id != LAST_LOCAL_LOOP_ID + 1) {
+			loop_id = id;
+		} else {
+			loop_id = 0;
+		}
+		/* Acquire adapter state lock. */
+		ADAPTER_STATE_LOCK(ha);
+
+		tq = ql_dev_init(ha, d_id, loop_id);
+
+		ADAPTER_STATE_UNLOCK(ha);
+	}
+
+	/*
+	 * Lun0 should always allocated since tq is
+	 * derived from lun queue in ql_els_passthru_entry
+	 * in the interrupt handler.
+	 */
+	sp->lun_queue = ql_lun_queue(ha, tq, 0);
+
+	DEVICE_QUEUE_LOCK(tq);
 	ql_timeout_insert(ha, tq, sp);
+	DEVICE_QUEUE_UNLOCK(tq);
+
 	ql_start_iocb(ha, sp);
 
 	return (QL_CONSUMED);
@@ -5194,13 +5591,12 @@
 	int			rval = FC_SUCCESS;
 	int			accept = 0;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    pkt->pkt_cmd_fhdr.d_id);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	bzero(&acc, sizeof (acc));
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 
-	if (CFG_IST(ha, CFG_CTRL_2425) && ha->topology & QL_N_PORT) {
+	if (CFG_IST(ha, CFG_N2N_SUPPORT) && ha->topology & QL_N_PORT) {
 		/*
 		 * d_id of zero in a FLOGI accept response in a point to point
 		 * topology triggers evaluation of N Port login initiative.
@@ -5219,10 +5615,9 @@
 			 * If the target port has initiative send
 			 * up a PLOGI about the new device.
 			 */
-			if ((ql_wwn_cmp(ha, (la_wwn_t *)&tq->port_name[0],
-			    (la_wwn_t *)(CFG_IST(ha, CFG_CTRL_2425) ?
-			    &ha->init_ctrl_blk.cb24.port_name[0] :
-			    &ha->init_ctrl_blk.cb.port_name[0])) == 1)) {
+			if (ql_wwn_cmp(ha, (la_wwn_t *)tq->port_name,
+			    (la_wwn_t *)ha->loginparams.nport_ww_name.raw_wwn)
+			    == 1) {
 				ha->send_plogi_timer = 3;
 			} else {
 				ha->send_plogi_timer = 0;
@@ -5253,13 +5648,8 @@
 		} else {
 			acc.common_service.cmn_features = 0x1b00;
 		}
-		CFG_IST(ha, CFG_CTRL_24258081) ?
-		    (acc.common_service.rx_bufsize = CHAR_TO_SHORT(
-		    ha->init_ctrl_blk.cb24.max_frame_length[0],
-		    ha->init_ctrl_blk.cb24.max_frame_length[1])) :
-		    (acc.common_service.rx_bufsize = CHAR_TO_SHORT(
-		    ha->init_ctrl_blk.cb.max_frame_length[0],
-		    ha->init_ctrl_blk.cb.max_frame_length[1]));
+		acc.common_service.rx_bufsize =
+		    ha->loginparams.common_service.rx_bufsize;
 		acc.common_service.conc_sequences = 0xff;
 		acc.common_service.relative_offset = 0x03;
 		acc.common_service.e_d_tov = 0x7d0;
@@ -5311,7 +5701,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -5337,10 +5727,8 @@
 	port_id_t	d_id;
 	ql_tgt_t	*tq;
 	la_els_logo_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    pkt->pkt_cmd_fhdr.d_id);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	bzero(&acc, sizeof (acc));
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
@@ -5388,13 +5776,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5422,8 +5806,7 @@
 	ql_srb_t		*sp = (ql_srb_t *)pkt->pkt_fca_private;
 	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    pkt->pkt_cmd_fhdr.d_id);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 
@@ -5433,7 +5816,13 @@
 
 		if ((ha->topology & QL_N_PORT) &&
 		    (tq->master_state == PD_STATE_PLOGI_COMPLETED)) {
+
+			/* always set lun_queue */
+			sp->lun_queue = ql_lun_queue(ha, tq, 0);
+
+			DEVICE_QUEUE_LOCK(tq);
 			ql_timeout_insert(ha, tq, sp);
+			DEVICE_QUEUE_UNLOCK(tq);
 			ql_start_iocb(ha, sp);
 			rval = QL_CONSUMED;
 		} else {
@@ -5456,18 +5845,44 @@
 			pkt->pkt_state = FC_PKT_SUCCESS;
 		}
 	} else {
-		la_els_rjt_t rjt;
+		/* in case of P2P, tq might not have been created yet */
+		if (ha->topology & QL_N_PORT) {
 
-		/* Build RJT. */
-		bzero(&rjt, sizeof (rjt));
-		rjt.ls_code.ls_code = LA_ELS_RJT;
+			/* Acquire adapter state lock. */
+			ADAPTER_STATE_LOCK(ha);
+			tq = ql_dev_init(ha, d_id, ha->n_port->n_port_handle);
+			ADAPTER_STATE_UNLOCK(ha);
 
-		ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&rjt,
-		    (uint8_t *)pkt->pkt_resp, sizeof (rjt), DDI_DEV_AUTOINCR);
+			/* always alloc lun #0 */
+			sp->lun_queue = ql_lun_queue(ha, tq, 0);
+			bcopy((void *)&ha->n_port->port_name[0],
+			    (void *) &tq->port_name[0], 8);
+			bcopy((void *)&ha->n_port->node_name[0],
+			    (void *) &tq->node_name[0], 8);
 
-		pkt->pkt_state = FC_PKT_TRAN_ERROR;
-		pkt->pkt_reason = FC_REASON_NO_CONNECTION;
-		EL(ha, "LA_ELS_RJT, FC_REASON_NO_CONNECTION\n");
+			DEVICE_QUEUE_LOCK(tq);
+			ql_timeout_insert(ha, tq, sp);
+			DEVICE_QUEUE_UNLOCK(tq);
+
+			ql_start_iocb(ha, sp);
+			rval = QL_CONSUMED;
+
+		} else {
+
+			la_els_rjt_t rjt;
+
+			/* Build RJT. */
+			bzero(&rjt, sizeof (rjt));
+			rjt.ls_code.ls_code = LA_ELS_RJT;
+
+			ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&rjt,
+			    (uint8_t *)pkt->pkt_resp, sizeof (rjt),
+			    DDI_DEV_AUTOINCR);
+
+			pkt->pkt_state = FC_PKT_TRAN_ERROR;
+			pkt->pkt_reason = FC_REASON_NO_CONNECTION;
+			EL(ha, "LA_ELS_RJT, FC_REASON_NO_CONNECTION\n");
+		}
 	}
 
 	if ((rval != FC_SUCCESS) && (rval != QL_CONSUMED)) {
@@ -5474,7 +5889,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -5499,10 +5914,8 @@
 ql_els_prlo(ql_adapter_state_t *ha, fc_packet_t *pkt)
 {
 	la_els_prli_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    pkt->pkt_cmd_fhdr.d_id);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", pkt->pkt_cmd_fhdr.d_id);
 
 	/* Build ACC. */
 	ddi_rep_get8(pkt->pkt_cmd_acc, (uint8_t *)&acc,
@@ -5516,13 +5929,9 @@
 
 	pkt->pkt_state = FC_PKT_SUCCESS;
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5552,9 +5961,8 @@
 	la_els_adisc_t		acc;
 	uint16_t		index, loop_id;
 	ql_mbx_data_t		mr;
-	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	bzero(&acc, sizeof (acc));
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
@@ -5649,13 +6057,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5680,12 +6084,11 @@
 	uint32_t		cnt;
 	conv_num_t		n;
 	port_id_t		d_id;
-	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
-	if (ha->topology & QL_SNS_CONNECTION) {
+	if (ha->topology & QL_FABRIC_CONNECTION) {
 		fc_linit_req_t els;
 		lfa_cmd_t lfa;
 
@@ -5744,13 +6147,9 @@
 		EL(ha, "LA_ELS_RJT, FC_REASON_NO_CONNECTION\n");
 	}
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5775,12 +6174,11 @@
 	uint32_t		cnt;
 	conv_num_t		n;
 	port_id_t		d_id;
-	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
-	if (ha->topology & QL_SNS_CONNECTION) {
+	if (ha->topology & QL_FABRIC_CONNECTION) {
 		ql_lpc_t els;
 		lfa_cmd_t lfa;
 
@@ -5815,7 +6213,7 @@
 		lfa.addr[2] = n.size8[2];
 		lfa.subcommand[1] = 0x71;
 		lfa.payload[4] = els.port_control;
-		bcopy((void *)&els.lpb[0], (void *)&lfa.payload[6], 32);
+		bcopy((void *)&els.lpb[0], (void *)&lfa.payload[6], 16);
 
 		if (ql_send_lfa(ha, &lfa) != QL_SUCCESS) {
 			pkt->pkt_state = FC_PKT_TRAN_ERROR;
@@ -5837,13 +6235,9 @@
 		EL(ha, "LA_ELS_RJT, FC_REASON_NO_CONNECTION\n");
 	}
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5868,12 +6262,11 @@
 	uint32_t		cnt;
 	conv_num_t		n;
 	port_id_t		d_id;
-	int			rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
-	if (ha->topology & QL_SNS_CONNECTION) {
+	if (ha->topology & QL_FABRIC_CONNECTION) {
 		fc_lsts_req_t els;
 		lfa_cmd_t lfa;
 
@@ -5928,13 +6321,9 @@
 		EL(ha, "LA_ELS_RJT, FC_REASON_NO_CONNECTION\n");
 	}
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed=%xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -5956,12 +6345,11 @@
 ql_els_scr(ql_adapter_state_t *ha, fc_packet_t *pkt)
 {
 	fc_scr_resp_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	bzero(&acc, sizeof (acc));
-	if (ha->topology & QL_SNS_CONNECTION) {
+	if (ha->topology & QL_FABRIC_CONNECTION) {
 		fc_scr_req_t els;
 
 		ddi_rep_get8(pkt->pkt_cmd_acc, (uint8_t *)&els,
@@ -5993,13 +6381,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -6022,12 +6406,11 @@
 ql_els_rscn(ql_adapter_state_t *ha, fc_packet_t *pkt)
 {
 	ql_rscn_resp_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	bzero(&acc, sizeof (acc));
-	if (ha->topology & QL_SNS_CONNECTION) {
+	if (ha->topology & QL_FABRIC_CONNECTION) {
 		/* Build ACC. */
 		acc.scr_acc = LA_ELS_ACC;
 
@@ -6044,13 +6427,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -6071,13 +6450,13 @@
  * Context:
  *	Kernel context.
  */
+/* ARGSUSED */
 static int
 ql_els_farp_req(ql_adapter_state_t *ha, fc_packet_t *pkt)
 {
 	ql_acc_rjt_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	bzero(&acc, sizeof (acc));
 
@@ -6089,13 +6468,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
+	QL_PRINT_3(ha, "done\n");
+
+	return (FC_SUCCESS);
 }
 
 /*
@@ -6121,9 +6496,8 @@
 ql_els_farp_reply(ql_adapter_state_t *ha, fc_packet_t *pkt)
 {
 	ql_acc_rjt_t	acc;
-	int		rval = FC_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	bzero(&acc, sizeof (acc));
 
@@ -6135,9 +6509,9 @@
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
-	return (rval);
+	return (FC_SUCCESS);
 }
 
 static int
@@ -6152,9 +6526,9 @@
 	la_els_rnid_t		*req;
 	size_t			req_len;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	req_len =  FCIO_RNID_MAX_DATA_LEN + sizeof (fc_rnid_hdr_t);
+	req_len = FCIO_RNID_MAX_DATA_LEN + sizeof (fc_rnid_hdr_t);
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 	index = ql_alpa_to_index[d_id.b.al_pa];
 
@@ -6192,7 +6566,7 @@
 	}
 
 	acc.ls_code.ls_code = LA_ELS_ACC;
-	bcopy(rnid_acc, &acc.hdr, req_len);
+	bcopy(rnid_acc, &acc.hdr, sizeof (fc_rnid_hdr_t));
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
 	    (uint8_t *)pkt->pkt_resp, sizeof (acc), DDI_DEV_AUTOINCR);
 
@@ -6199,7 +6573,7 @@
 	kmem_free(rnid_acc, req_len);
 	pkt->pkt_state = FC_PKT_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (FC_SUCCESS);
 }
@@ -6214,7 +6588,7 @@
 	uint16_t		index;
 	la_els_rls_acc_t	acc;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 	index = ql_alpa_to_index[d_id.b.al_pa];
@@ -6260,7 +6634,7 @@
 	acc.ls_code.ls_code = LA_ELS_ACC;
 	acc.rls_link_params.rls_link_fail = rls_acc->rls_link_fail;
 	acc.rls_link_params.rls_sync_loss = rls_acc->rls_sync_loss;
-	acc.rls_link_params.rls_sig_loss  = rls_acc->rls_sig_loss;
+	acc.rls_link_params.rls_sig_loss = rls_acc->rls_sig_loss;
 	acc.rls_link_params.rls_invalid_word = rls_acc->rls_invalid_word;
 	acc.rls_link_params.rls_invalid_crc = rls_acc->rls_invalid_crc;
 	ddi_rep_put8(pkt->pkt_resp_acc, (uint8_t *)&acc,
@@ -6269,7 +6643,7 @@
 	kmem_free(rls_acc, sizeof (*rls_acc));
 	pkt->pkt_state = FC_PKT_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (FC_SUCCESS);
 }
@@ -6279,12 +6653,12 @@
 {
 	port_id_t	d_id;
 	ql_srb_t	*sp;
-	fc_unsol_buf_t  *ubp;
+	fc_unsol_buf_t	*ubp;
 	ql_link_t	*link, *next_link;
 	int		rval = FC_SUCCESS;
 	int		cnt = 5;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/*
 	 * we need to ensure that q->outcnt == 0, otherwise
@@ -6323,8 +6697,7 @@
 	if ((rval != FC_SUCCESS) ||
 	    (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) &&
 	    pkt->pkt_comp)) {
-		QL_PRINT_3(CE_CONT, "(%d): done, busy or async\n",
-		    ha->instance);
+		QL_PRINT_3(ha, "done, busy or async\n");
 		return (rval);
 	}
 
@@ -6334,7 +6707,7 @@
 	 * callback queue.
 	 */
 	TASK_DAEMON_LOCK(ha);
-	for (link = ha->callback_queue.first; link != NULL;
+	for (link = ha->unsol_callback_queue.first; link != NULL;
 	    link = next_link) {
 		next_link = link->next;
 		sp = link->base_address;
@@ -6353,7 +6726,7 @@
 	}
 	TASK_DAEMON_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -6383,9 +6756,17 @@
 	uint16_t		loop_id, first_loop_id, last_loop_id;
 	int			rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    d_id.b24);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", d_id.b24);
 
+	/* Do not login vports */
+	for (vha = ha->pha; vha != NULL; vha = vha->vp_next) {
+		if (vha->d_id.b24 == d_id.b24) {
+			EL(ha, "failed=%xh, d_id=%xh vp_index=%xh\n",
+			    QL_FUNCTION_FAILED, d_id.b24, vha->vp_index);
+			return (QL_FUNCTION_FAILED);
+		}
+	}
+
 	/* Get head queue index. */
 	index = ql_alpa_to_index[d_id.b.al_pa];
 
@@ -6414,8 +6795,14 @@
 	}
 
 	/* Special case for Nameserver */
-	if (d_id.b24 == 0xFFFFFC) {
-		loop_id = (uint16_t)(CFG_IST(ha, CFG_CTRL_24258081) ?
+	if (d_id.b24 == FS_NAME_SERVER) {
+		if (!(ha->topology & QL_FABRIC_CONNECTION)) {
+			EL(ha, "failed=%xh, d_id=%xh no fabric\n",
+			    QL_FUNCTION_FAILED, d_id.b24);
+			return (QL_FUNCTION_FAILED);
+		}
+
+		loop_id = (uint16_t)(CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 		    SNS_24XX_HDL : SIMPLE_NAME_SERVER_LOOP_ID);
 		if (tq == NULL) {
 			ADAPTER_STATE_LOCK(ha);
@@ -6427,7 +6814,7 @@
 				return (QL_FUNCTION_FAILED);
 			}
 		}
-		if (!(CFG_IST(ha, CFG_CTRL_8021))) {
+		if (!(CFG_IST(ha, CFG_CTRL_82XX))) {
 			rval = ql_login_fabric_port(ha, tq, loop_id);
 			if (rval == QL_SUCCESS) {
 				tq->loop_id = loop_id;
@@ -6434,9 +6821,6 @@
 				tq->flags |= TQF_FABRIC_DEVICE;
 				(void) ql_get_port_database(ha, tq, PDF_NONE);
 			}
-		} else {
-			ha->topology = (uint8_t)
-			    (ha->topology | QL_SNS_CONNECTION);
 		}
 	/* Check for device already logged in. */
 	} else if (tq != NULL && VALID_DEVICE_ID(ha, loop_id)) {
@@ -6455,9 +6839,9 @@
 				DEVICE_QUEUE_UNLOCK(tq);
 			}
 		}
-	} else if (ha->topology & QL_SNS_CONNECTION) {
+	} else if (ha->topology & QL_FABRIC_CONNECTION) {
 		/* Locate unused loop ID. */
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			first_loop_id = 0;
 			last_loop_id = LAST_N_PORT_HDL;
 		} else if (ha->topology & QL_F_PORT) {
@@ -6534,7 +6918,9 @@
 
 			case QL_LOOP_ID_USED:
 				tq->loop_id = PORT_NO_LOOP_ID;
+				ADAPTER_STATE_LOCK(ha);
 				loop_id = ha->pha->free_loop_id++;
+				ADAPTER_STATE_UNLOCK(ha);
 				break;
 
 			case QL_ALL_IDS_IN_USE:
@@ -6557,7 +6943,8 @@
 	}
 
 	if (rval != QL_SUCCESS) {
-		EL(ha, "failed=%xh, d_id=%xh\n", rval, d_id.b24);
+		EL(ha, "failed, rval=%xh, d_id=%xh\n",
+		    rval, d_id.b24);
 	} else {
 		EL(ha, "d_id=%xh, loop_id=%xh, "
 		    "wwpn=%02x%02x%02x%02x%02x%02x%02x%02xh\n", tq->d_id.b24,
@@ -6593,13 +6980,11 @@
 	ql_tgt_t	*newq;
 	ql_mbx_data_t	mr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    tq->d_id.b24);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", tq->d_id.b24);
 
 	/*
-	 * QL_PARAMETER_ERROR also means the firmware is
-	 * not able to allocate PCB entry due to resource
-	 * issues, or collision.
+	 * QL_PARAMETER_ERROR also means the firmware is not able to allocate
+	 * PCB entry due to resource issues, or collision.
 	 */
 	do {
 		rval = ql_login_fport(ha, tq, loop_id, LFF_NONE, &mr);
@@ -6607,11 +6992,11 @@
 		    ((rval == QL_COMMAND_ERROR) && (mr.mb[1] == 2 ||
 		    mr.mb[1] == 3 || mr.mb[1] == 7 || mr.mb[1] == 0xd))) {
 			retry++;
-			drv_usecwait(10 * MILLISEC);
+			drv_usecwait(ha->plogi_params->retry_dly_usec);
 		} else {
 			break;
 		}
-	} while (retry < 5);
+	} while (retry < ha->plogi_params->retry_cnt);
 
 	switch (rval) {
 	case QL_SUCCESS:
@@ -6646,10 +7031,10 @@
 			 * code is needed to bail out when the worst
 			 * case happens - or as used to happen before
 			 */
-			QL_PRINT_2(CE_CONT, "(%d,%d): Loop ID is now "
+			QL_PRINT_2(ha, "Loop ID is now "
 			    "reassigned; old pairs: [%xh, %xh] and [%xh, %xh];"
 			    "new pairs: [%xh, unknown] and [%xh, %xh]\n",
-			    ha->instance, ha->vp_index, tq->d_id.b24, loop_id,
+			    tq->d_id.b24, loop_id,
 			    newq->d_id.b24, newq->loop_id, tq->d_id.b24,
 			    newq->d_id.b24, loop_id);
 
@@ -6691,9 +7076,12 @@
 				rval = QL_MEMORY_ALLOC_FAILED;
 				break;
 
+			case 0xd:
 			case 4:
 				rval = QL_FUNCTION_TIMEOUT;
 				break;
+			case 1:
+			case 5:
 			case 7:
 				rval = QL_FABRIC_NOT_INITIALIZED;
 				break;
@@ -6714,7 +7102,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -6740,7 +7128,7 @@
 	ql_tgt_t	*tq;
 	uint16_t	index;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Get head queue index. */
 	index = ql_alpa_to_index[d_id.b.al_pa];
@@ -6761,7 +7149,7 @@
 		tq->loop_id = PORT_NO_LOOP_ID;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -6789,13 +7177,11 @@
 	uint16_t	index;
 	ql_tgt_t	*tq;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh, loop_id=%xh\n",
-	    ha->instance, d_id.b24, loop_id);
+	QL_PRINT_3(ha, "started, d_id=%xh, loop_id=%xh\n", d_id.b24, loop_id);
 
 	index = ql_alpa_to_index[d_id.b.al_pa];
 
 	/* If device queue exists, set proper loop ID. */
-	tq = NULL;
 	for (link = ha->dev[index].first; link != NULL; link = link->next) {
 		tq = link->base_address;
 		if (tq->d_id.b24 == d_id.b24) {
@@ -6806,13 +7192,11 @@
 			tq->qfull_retry_count = ha->qfull_retry_count;
 
 			break;
-		} else {
-			tq = NULL;
 		}
 	}
 
 	/* If device does not have queue. */
-	if (tq == NULL) {
+	if (link == NULL) {
 		tq = (ql_tgt_t *)kmem_zalloc(sizeof (ql_tgt_t), KM_SLEEP);
 		if (tq != NULL) {
 			/*
@@ -6820,9 +7204,7 @@
 			 * does not block interrupts.
 			 */
 			mutex_init(&tq->mutex, NULL, MUTEX_DRIVER,
-			    (ha->iflags & IFLG_INTR_AIF) ?
-			    (void *)(uintptr_t)ha->intr_pri :
-			    (void *)(uintptr_t)ha->iblock_cookie);
+			    ha->intr_pri);
 
 			tq->d_id.b24 = d_id.b24;
 			tq->loop_id = loop_id;
@@ -6842,7 +7224,7 @@
 		EL(ha, "failed, d_id=%xh, loop_id=%xh\n", d_id.b24, loop_id);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (tq);
 }
@@ -6866,11 +7248,13 @@
 	uint16_t	index;
 	ql_lun_t	*lq;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	for (link = tq->lun_queues.first; link != NULL; link = link->next) {
 		lq = link->base_address;
 		if (lq->cmd.first != NULL) {
+			EL(ha, "cmd %ph pending in lq=%ph, lun=%xh\n",
+			    lq->cmd.first, lq, lq->lun_no);
 			return;
 		}
 	}
@@ -6900,7 +7284,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -6909,8 +7293,8 @@
  *
  * Input:
  *	ha:	adapter state pointer.
- *	tq:	target queue.
- *	lun:	LUN number.
+ *	tq:		target queue.
+ *	lun_addr:	LUN number.
  *
  * Returns:
  *	NULL = failure
@@ -6919,43 +7303,56 @@
  *	Kernel context.
  */
 static ql_lun_t *
-ql_lun_queue(ql_adapter_state_t *ha, ql_tgt_t *tq, uint16_t lun)
+ql_lun_queue(ql_adapter_state_t *ha, ql_tgt_t *tq, uint64_t lun_addr)
 {
 	ql_lun_t	*lq;
 	ql_link_t	*link;
+	uint16_t	lun_no, lun_no_tmp;
+	fcp_ent_addr_t	*fcp_ent_addr = (fcp_ent_addr_t *)&lun_addr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Fast path. */
-	if (tq->last_lun_queue != NULL && tq->last_lun_queue->lun_no == lun) {
-		QL_PRINT_3(CE_CONT, "(%d): fast done\n", ha->instance);
+	if (tq->last_lun_queue != NULL && tq->last_lun_queue->lun_addr ==
+	    lun_addr) {
+		QL_PRINT_3(ha, "fast done\n");
 		return (tq->last_lun_queue);
 	}
 
-	if (lun >= MAX_LUNS) {
-		EL(ha, "Exceeded MAX_LUN=%d, lun=%d\n", MAX_LUNS, lun);
-		return (NULL);
-	}
 	/* If device queue exists, set proper loop ID. */
-	lq = NULL;
 	for (link = tq->lun_queues.first; link != NULL; link = link->next) {
 		lq = link->base_address;
-		if (lq->lun_no == lun) {
-			QL_PRINT_3(CE_CONT, "(%d): found done\n", ha->instance);
+		if (lq->lun_addr == lun_addr) {
+			QL_PRINT_3(ha, "found done\n");
 			tq->last_lun_queue = lq;
 			return (lq);
 		}
 	}
 
-	/* If queue does exist. */
-	lq = (ql_lun_t *)kmem_zalloc(sizeof (ql_lun_t), KM_SLEEP);
+	/* Check the LUN addressing levels. */
+	if (fcp_ent_addr->ent_addr_1 != 0 || fcp_ent_addr->ent_addr_2 != 0 ||
+	    fcp_ent_addr->ent_addr_3 != 0) {
+		EL(ha, "Unsupported LUN Addressing level=0x%llxh", lun_addr);
+	}
 
-	/* Initialize LUN queue. */
+	lun_no_tmp = CHAR_TO_SHORT(lobyte(fcp_ent_addr->ent_addr_0),
+	    hibyte(fcp_ent_addr->ent_addr_0));
+
+	lun_no = lun_no_tmp & ~(QL_LUN_AM_MASK << 8);
+
+	if (lun_no_tmp & (QL_LUN_AM_LUN << 8)) {
+		EL(ha, "Unsupported first level LUN Addressing method=%xh, "
+		    "lun=%d(%xh)\n", lun_no_tmp & (QL_LUN_AM_MASK << 8),
+		    lun_no, lun_no_tmp);
+	}
+
+	/* Create and initialize LUN queue. */
+	lq = (ql_lun_t *)kmem_zalloc(sizeof (ql_lun_t), KM_SLEEP);
 	if (lq != NULL) {
 		lq->link.base_address = lq;
-
-		lq->lun_no = lun;
 		lq->target_queue = tq;
+		lq->lun_addr = lun_addr;
+		lq->lun_no = lun_no;
 
 		DEVICE_QUEUE_LOCK(tq);
 		ql_add_link_b(&tq->lun_queues, &lq->link);
@@ -6963,7 +7360,7 @@
 		tq->last_lun_queue = lq;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (lq);
 }
@@ -6990,9 +7387,9 @@
 	port_id_t	d_id;
 	ql_tgt_t	*tq;
 	uint64_t	*ptr;
-	uint16_t	lun;
+	uint64_t	fcp_ent_addr = 0;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	tq = (ql_tgt_t *)pkt->pkt_fca_device;
 	if (tq == NULL) {
@@ -7002,11 +7399,9 @@
 	}
 
 	sp->fcp = (struct fcp_cmd *)pkt->pkt_cmd;
-	lun = CHAR_TO_SHORT(lobyte(sp->fcp->fcp_ent_addr.ent_addr_0),
-	    hibyte(sp->fcp->fcp_ent_addr.ent_addr_0));
-
+	fcp_ent_addr = *(uint64_t *)(&sp->fcp->fcp_ent_addr);
 	if (tq != NULL &&
-	    (sp->lun_queue = ql_lun_queue(ha, tq, lun)) != NULL) {
+	    (sp->lun_queue = ql_lun_queue(ha, tq, fcp_ent_addr)) != NULL) {
 
 		/*
 		 * zero out FCP response; 24 Bytes
@@ -7043,7 +7438,7 @@
 
 				/* Setup IOCB count. */
 				if (pkt->pkt_data_cookie_cnt > ha->cmd_segs &&
-				    (!CFG_IST(ha, CFG_CTRL_8021) ||
+				    (!CFG_IST(ha, CFG_CTRL_82XX) ||
 				    sp->sg_dma.dma_handle == NULL)) {
 					uint32_t	cnt;
 
@@ -7059,7 +7454,7 @@
 					}
 				}
 			}
-			QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+			QL_PRINT_3(ha, "done\n");
 
 			return (ql_start_cmd(ha, tq, pkt, sp));
 		}
@@ -7067,11 +7462,12 @@
 		pkt->pkt_state = FC_PKT_LOCAL_RJT;
 		pkt->pkt_reason = FC_REASON_NO_CONNECTION;
 
-		if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp)
-			ql_awaken_task_daemon(ha, sp, 0, 0);
+		if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp) {
+			ql_io_comp(sp);
+		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (FC_SUCCESS);
 }
@@ -7095,26 +7491,24 @@
 {
 	fcp_rsp_t		*fcpr;
 	struct fcp_rsp_info	*rsp;
-	uint16_t		lun;
+	ql_lun_t		*lq = sp->lun_queue;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	fcpr = (fcp_rsp_t *)pkt->pkt_resp;
-	rsp = (struct fcp_rsp_info *)pkt->pkt_resp + sizeof (fcp_rsp_t);
+	rsp = (struct fcp_rsp_info *)(pkt->pkt_resp + sizeof (fcp_rsp_t));
 
 	bzero(fcpr, pkt->pkt_rsplen);
 
 	fcpr->fcp_u.fcp_status.rsp_len_set = 1;
 	fcpr->fcp_response_len = 8;
-	lun = CHAR_TO_SHORT(lobyte(sp->fcp->fcp_ent_addr.ent_addr_0),
-	    hibyte(sp->fcp->fcp_ent_addr.ent_addr_0));
 
 	if (sp->fcp->fcp_cntl.cntl_clr_aca) {
-		if (ql_clear_aca(ha, tq, lun) != QL_SUCCESS) {
+		if (ql_clear_aca(ha, tq, lq) != QL_SUCCESS) {
 			rsp->rsp_code = FCP_TASK_MGMT_FAILED;
 		}
 	} else if (sp->fcp->fcp_cntl.cntl_reset_lun) {
-		if (ql_lun_reset(ha, tq, lun) != QL_SUCCESS) {
+		if (ql_lun_reset(ha, tq, lq) != QL_SUCCESS) {
 			rsp->rsp_code = FCP_TASK_MGMT_FAILED;
 		}
 	} else if (sp->fcp->fcp_cntl.cntl_reset_tgt) {
@@ -7123,11 +7517,11 @@
 			rsp->rsp_code = FCP_TASK_MGMT_FAILED;
 		}
 	} else if (sp->fcp->fcp_cntl.cntl_clr_tsk) {
-		if (ql_clear_task_set(ha, tq, lun) != QL_SUCCESS) {
+		if (ql_clear_task_set(ha, tq, lq) != QL_SUCCESS) {
 			rsp->rsp_code = FCP_TASK_MGMT_FAILED;
 		}
 	} else if (sp->fcp->fcp_cntl.cntl_abort_tsk) {
-		if (ql_abort_task_set(ha, tq, lun) != QL_SUCCESS) {
+		if (ql_abort_task_set(ha, tq, lq) != QL_SUCCESS) {
 			rsp->rsp_code = FCP_TASK_MGMT_FAILED;
 		}
 	} else {
@@ -7138,10 +7532,10 @@
 
 	/* Do command callback. */
 	if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp) {
-		ql_awaken_task_daemon(ha, sp, 0, 0);
+		ql_io_comp(sp);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -7166,7 +7560,7 @@
 	port_id_t	d_id;
 	ql_tgt_t	*tq;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	tq = (ql_tgt_t *)pkt->pkt_fca_device;
 	if (tq == NULL) {
@@ -7197,7 +7591,7 @@
 		} else {
 			sp->req_cnt = 1;
 		}
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 
 		return (ql_start_cmd(ha, tq, pkt, sp));
 	} else {
@@ -7205,10 +7599,10 @@
 		pkt->pkt_reason = FC_REASON_NO_CONNECTION;
 
 		if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp)
-			ql_awaken_task_daemon(ha, sp, 0, 0);
+			ql_io_comp(sp);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (FC_SUCCESS);
 }
@@ -7239,7 +7633,7 @@
 	ql_srb_t	*sp;
 	int		rval;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	ddi_rep_get8(pkt->pkt_cmd_acc, (uint8_t *)&hdr,
 	    (uint8_t *)pkt->pkt_cmd, sizeof (hdr), DDI_DEV_AUTOINCR);
@@ -7258,6 +7652,7 @@
 	switch (hdr.ct_fcstype) {
 	case FCSTYPE_DIRECTORY:
 	case FCSTYPE_MGMTSERVICE:
+
 		/* An FCA must make sure that the header is in big endian */
 		ql_cthdr_endian(pkt->pkt_cmd_acc, pkt->pkt_cmd, B_FALSE);
 
@@ -7264,6 +7659,7 @@
 		d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 		tq = ql_d_id_to_queue(ha, d_id);
 		sp = (ql_srb_t *)pkt->pkt_fca_private;
+
 		if (tq == NULL ||
 		    (sp->lun_queue = ql_lun_queue(ha, tq, 0)) == NULL) {
 			pkt->pkt_state = FC_PKT_LOCAL_RJT;
@@ -7272,6 +7668,13 @@
 			break;
 		}
 
+		if (tq->flags & TQF_LOGIN_NEEDED) {
+			DEVICE_QUEUE_LOCK(tq);
+			tq->flags &= ~TQF_LOGIN_NEEDED;
+			DEVICE_QUEUE_UNLOCK(tq);
+			(void) ql_login_fport(ha, tq, tq->loop_id, LFF_NONE,
+			    NULL);
+		}
 		/*
 		 * Services data is bound to pkt_cmd_dma
 		 */
@@ -7286,8 +7689,8 @@
 		if (pkt->pkt_resp_cookie_cnt > MS_DATA_SEGMENTS) {
 			cnt = pkt->pkt_resp_cookie_cnt - MS_DATA_SEGMENTS;
 			sp->req_cnt =
-			    (uint16_t)(cnt / CONT_TYPE_1_DATA_SEGMENTS);
-			if (cnt % CONT_TYPE_1_DATA_SEGMENTS) {
+			    (uint16_t)(cnt / ha->cmd_cont_segs);
+			if (cnt % ha->cmd_cont_segs) {
 				sp->req_cnt = (uint16_t)(sp->req_cnt + 2);
 			} else {
 				sp->req_cnt++;
@@ -7297,8 +7700,7 @@
 		}
 		rval = ql_start_cmd(ha, tq, pkt, sp);
 
-		QL_PRINT_3(CE_CONT, "(%d): done, ql_start_cmd=%xh\n",
-		    ha->instance, rval);
+		QL_PRINT_3(ha, "done, ql_start_cmd=%xh\n", rval);
 
 		return (rval);
 
@@ -7323,11 +7725,10 @@
 
 	/* Do command callback. */
 	if (!(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp) {
-		ql_awaken_task_daemon(ha, (ql_srb_t *)pkt->pkt_fca_private,
-		    0, 0);
+		ql_io_comp((ql_srb_t *)pkt->pkt_fca_private);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (FC_SUCCESS);
 }
@@ -7437,7 +7838,7 @@
 	time_t		poll_wait = 0;
 	ql_lun_t	*lq = sp->lun_queue;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	sp->handle = 0;
 
@@ -7493,7 +7894,7 @@
 		/* Call done routine to handle completions. */
 		sp->cmd.next = NULL;
 		DEVICE_QUEUE_UNLOCK(tq);
-		ql_done(&sp->cmd);
+		ql_done(&sp->cmd, B_FALSE);
 	} else {
 		if (ddi_in_panic() && (sp->flags & SRB_POLL)) {
 			int do_lip = 0;
